#include "StdAfx.h"
#include "resource.h"
#include ".\accpage.h"
#include "../nsmsgs/general_strings.h"

const static char HEADER_ACCOUNT[]	= "AJEg";
const static char HEADER_INFO[]		= "ڑ";
const static char HEADER_CHANNEL[]	= "`l";

const static char MSG_ACCOUT_EXISTS[]	= "̃AJEg͊ɑ݂܂";
const static char MSG_TITLE[]			= "VKAJEg";

enum{
	COL_ACCOUNT,
	COL_INFO,
	COL_CHANNEL,
	NUM_OF_COL,
};

//******************************************************************
// 
//******************************************************************

CAccPage::CAccPage(AccountList &al)
: m_plist(&al)
{
	m_nIDTemplate = IDD_PAGE_ACC;
}

CAccPage::~CAccPage(void)
{
}

//******************************************************************
// 
//******************************************************************

BOOL CAccPage::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg ){
	case WM_NOTIFY:
		if( LOWORD(wParam) == IDC_ACC ){
			switch( ((LPNMHDR)lParam)->code ){
			case NM_DBLCLK:
				OnListDblClick((NMITEMACTIVATE*)lParam);
				break;
			default:
				return FALSE;
			}
			return TRUE;
		}
		return FALSE;

	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDC_ADD: OnClickAdd(); break;
		case IDC_SETTING: OnClickSetting(); break;
		case IDC_DEL: OnClickDel(); break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}

	return TRUE;
}

BOOL CAccPage::InitDlgCtrl()
{
	LVCOLUMN lvc;
	HWND hItem;

	// Xg
	hItem = GetDlgItem(IDC_ACC);
	ListView_SetExtendedListViewStyle(hItem, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_LABELTIP);

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_SUBITEM | LVCF_TEXT;
	lvc.fmt = LVCFMT_LEFT;

	lvc.pszText = (LPSTR)HEADER_ACCOUNT;
	lvc.cx = 100;
	lvc.iSubItem = COL_ACCOUNT;
	ListView_InsertColumn(hItem, COL_ACCOUNT, &lvc);

	lvc.pszText = (LPSTR)HEADER_INFO;
	lvc.cx = 200;
	lvc.iSubItem = COL_INFO;
	ListView_InsertColumn(hItem, COL_INFO, &lvc);

	lvc.pszText = (LPSTR)HEADER_CHANNEL;
	lvc.cx = 200;
	lvc.iSubItem = COL_CHANNEL;
	ListView_InsertColumn(hItem, COL_CHANNEL, &lvc);

	UpdateList();
	return TRUE;
}
/*
BOOL CAccPage::GetDlgCtrlValue()
{

	return TRUE;
}
*/
//******************************************************************
// 
//******************************************************************

void CAccPage::OnListDblClick(NMITEMACTIVATE* pNMIA)
{
	EditAccSetting(pNMIA->iItem);
}

void CAccPage::OnClickAdd()
{
	CAccDlg dlg;

	for(;;){
		if( dlg.DoModal(m_hInstance, m_hDlgWnd) != IDOK )
			return;
		if( ! AccountExists(dlg.GetAccount()) )
			break;
	}

	AccSetting *as = new AccSetting;
	dlg.GetAccSetting(*as);
	m_plist->push_back(as);

	UpdateList();
	ListView_SetItemState(GetDlgItem(IDC_ACC), m_plist->size() - 1, LVIS_SELECTED, LVIS_SELECTED);
	ListView_SetSelectionMark(GetDlgItem(IDC_ACC), m_plist->size() - 1);
}

void CAccPage::OnClickSetting()
{
	int ich = GetCurSelect();

	EditAccSetting(ich);
}

void CAccPage::OnClickDel()
{
	int ich = GetCurSelect();

	if( (0 <= ich) && ((u_int)ich <= m_plist->size()) ){
		AccSetting *as = (*m_plist)[ich];
		as->DeleteConChList();
		delete as;
		m_plist->erase(m_plist->begin() + ich);

		UpdateList();
		ListView_SetItemState(GetDlgItem(IDC_ACC), ich - 1, LVIS_SELECTED, LVIS_SELECTED);
		ListView_SetSelectionMark(GetDlgItem(IDC_ACC), ich - 1);
	}
}

//******************************************************************
// 
//******************************************************************

bool CAccPage::AccountExists(LPCSTR acc, AccSetting *ac/*=NULL*/)
{
	int size = m_plist->size();
	AccSetting *as;

	for( int i = 0; i < size; ++i ){
		as = (*m_plist)[i];
		if( (as != ac) && (as->acc == acc) ){
			::MessageBox(m_hDlgWnd, MSG_ACCOUT_EXISTS,
				MSG_TITLE, MB_OK|MB_ICONWARNING|MB_APPLMODAL);
			return true;
		}
	}
	return false;
}

int CAccPage::GetCurSelect()
{
	HWND hList = GetDlgItem(IDC_ACC);
	return ListView_GetSelectionMark(hList);
}

void CAccPage::EditAccSetting(int i)
{
	CAccDlg dlg;
	AccSetting *as;

	if( m_plist->size() <= (u_int)i ){
		_ASSERT(FALSE);
		return;
	}

	as = (*m_plist)[i];
	dlg.SetAccSetting(*as);
	for(;;){
		if( dlg.DoModal(m_hInstance, m_hDlgWnd) != IDOK )
			return;
		if( ! AccountExists(dlg.GetAccount(), as) )
			break;
	}

	dlg.GetAccSetting(*as);

	UpdateList();
	ListView_SetItemState(GetDlgItem(IDC_ACC), i, LVIS_SELECTED, LVIS_SELECTED);
	ListView_SetSelectionMark(GetDlgItem(IDC_ACC), i);
}

void CAccPage::UpdateList()
{
	int iItem;
	HWND hList;
	LVITEM lvi;
	int ed;
	std::string str;

	hList = GetDlgItem(IDC_ACC);
	::SendMessage(hList, LVM_DELETEALLITEMS, 0, 0);

	iItem = 0;
	lvi.mask = LVIF_TEXT;
	ed = m_plist->size();
	for( int i = 0; i < ed; ++i ){
		const AccSetting *as = (*m_plist)[i];

		lvi.iItem = iItem;
		lvi.iSubItem = COL_ACCOUNT;
		lvi.pszText = (LPSTR)as->acc.c_str();
		ListView_InsertItem(hList, &lvi);

		CreateInfoStr(str, as);
		ListView_SetItemText(hList, iItem, COL_INFO, (LPSTR)str.c_str());

		CreateChStr(str, as->chs);
		ListView_SetItemText(hList, iItem, COL_CHANNEL, (LPSTR)str.c_str());

		iItem++;
	}

	for( int i = 0; i < NUM_OF_COL; ++i ){
		ListView_SetColumnWidth(hList, i, LVSCW_AUTOSIZE_USEHEADER);
	}
}

void CAccPage::CreateInfoStr(std::string &out, const AccSetting *as)
{
	char buf[16];
	_itoa_s(as->port, buf, 10);

	out = as->nick;
	out += "@";
	out += as->host;
	out += ":";
	out += buf;
}

void CAccPage::CreateChStr(std::string &out, const ConChList &ccl)
{
	int size = ccl.size();

	out = NULL_STRING;
	for( int i = 0; i < size; ++i ){
		ConChannel *cc = ccl[i];
		if( i != 0 ) out += ", ";
		out += cc->bAutoJoin ? "": "~";
		out += cc->name;
	}
}
