#pragma once

class CFileTime
{
private:
	const static u_int64 SECOND = 10 * 1000 * 1000;
private:
	FILETIME m_time;

public:
	CFileTime()
	{
	}
	CFileTime(u_int64 time)
	{
		toNum(m_time) = time;
	}
	~CFileTime()
	{
	}
	operator LPFILETIME()
	{ return &m_time; }
	operator LARGE_INTEGER*()
	{ return (LARGE_INTEGER*)&m_time; }
	operator FILETIME&()
	{ return m_time; }
	CFileTime operator +(FILETIME &time)
	{
		CFileTime t(toNum(m_time) + toNum(time));
		return t;
	}
	CFileTime operator -(FILETIME &time)
	{
		CFileTime t(toNum(m_time) - toNum(time));
		return t;
	}
	CFileTime operator -(int second)
	{
		CFileTime t(toNum(m_time) - (__int64)second * SECOND);
		return t;
	}
	bool operator <(FILETIME &time)
	{
		return toNum(m_time) < toNum(time);
	}
	CFileTime& operator =(FILETIME &time)
	{
		m_time = time;
		return *this;
	}
	CFileTime& operator +(int second)
	{
		toNum(m_time) += second * SECOND;
		return *this;
	}
	CFileTime& operator +=(int second)
	{
		*this = *this + second;
		return *this;
	}

private:
	static u_int64& toNum(FILETIME &time)
	{
		return *(u_int64*)&time;
	}
};
