#pragma once
#include "IRCSocket.h"

typedef std::vector<LPCSTR> ParamList;

class CIRCCmd
{
private:

private:
	CIRCSocket* m_pSocket;
	char m_buf[IRC_MESSAGE_SIZE+1];
	int m_buf_filled;

public:
	CIRCCmd(void);
	~CIRCCmd(void);

	bool Cmd(LPCSTR msg);
//	bool Cmd(LPCSTR cmd, ...);

	void Pass(LPCSTR pass);
	void User();
	void Ison();
	void Whois();
	void List();
	void Who(LPCSTR q);
	void Join(LPCSTR ch);
	void Part(LPCSTR ch);
	void Topic();
	void Invite(LPCSTR user, LPCSTR ch);
	void Names();
	bool Privmsg(LPCSTR target, LPCSTR msg);
	void Nick(LPCSTR nick);
	void Away();
	void Mode();
	void Kick(LPCSTR ch, LPCSTR user);
	void Pong(LPCSTR target);
	void Quit(LPCSTR msg);
	void Notice(LPCSTR target, LPCSTR msg);

	void SetSocket(CIRCSocket *p)
	{ m_pSocket = p; }

public:
	static void SplitMsg(LPCSTR in, LPSTR buf, LPCSTR &from,
		LPCSTR &host, LPSTR &cmd, LPCSTR &param);
	static void SplitParam(ParamList &list, LPSTR param);

private:
	int GetCmdPenalty(LPCSTR cmd);
	void Send(int penalty)
	{
		_ASSERT(m_buf_filled <= IRC_MESSAGE_SIZE);
		m_buf[m_buf_filled] = '\0';
		penalty += m_buf_filled/100;
		m_pSocket->Send(m_buf, penalty);
	}
	void Clear()
	{ m_buf_filled = 0; }
	bool Append(LPCSTR str, int len)
	{
		if( m_buf_filled + len > IRC_MESSAGE_SIZE )
			return false;
		memcpy(m_buf + m_buf_filled, str, len);
		m_buf_filled += len;
		return true;
	}
	bool ConcatSend(int penalty, ...);
};
