#pragma once
#include <string>
#include "IRCSession.h"

class CIRCNsm
{
private:
	const HNsmConnection m_hCon;
	int m_gid;

private:
	static HNsmEvent ms_hLogEvt;

public:
	CIRCNsm(LPCSTR lpAcc, HNsmConnection &hCon);
	~CIRCNsm(void);
	CIRCNsm& operator =(CIRCNsm &/*other*/)
	{ _ASSERT(FALSE); return *this; }

	void Connected() const;
	void Disconnect() const;
	void AddChannel(LPCSTR ch);
	void RemChannel(int nGroupID) const;
	int GetGroupId(LPCSTR name) const;
	void ResetChannel(int nGroupID) const;
	void AddMember(LPCSTR ch, LPCSTR nick) const;
	void RemMember(LPCSTR ch, LPCSTR nick) const;
	void ChangeUserName(LPCSTR newName) const;

	CIRCSession* CreateSession(LPCSTR name) const;
	void GetSessionCaption(HNsmSession hSession, std::string &cap) const;
	void DoLog(LPCSTR header, LPCSTR body) const;
	void Error(LPCSTR msg) const;
	void Warning(LPCSTR msg) const;

	void GetGroupName(int nGroupID, std::string &name) const;

public:
	static void SetLogEvt(HNsmEvent evt)
	{ ms_hLogEvt = evt; }
};
