#pragma once
#include <map>
#include "IRCConnection.h"
#include "../nsmsgs/NsmPlugin.h"

class CIRCPlugin :
	public CNsmPlugin
{
// Singleton -->
private:
	static CIRCPlugin m_singleton;

private:
	CIRCPlugin(void);
public:
	~CIRCPlugin(void);

public:
	static CIRCPlugin& GetInstance()
	{
		return m_singleton;
	}
// <-- Singleton

private:
	typedef std::map<HNsmConnection, CIRCConnection*> ConMap;

private:
	ConMap m_cons;
	bool m_bWSAStartupSuccess;

// T[rXƃCxgtbN`
public:
	DEFINE_SERVICE1(ConConnect, PLoginInfo);
	DEFINE_SERVICE1(ConDisconnect, HNsmConnection);
//	DEFINE_SERVICE2(ConChangeUserStatus, HNsmConnection, PUserStatusInfo);
	DEFINE_SERVICE2(ConChangeUserName, HNsmConnection, PUserNameInfo);
//	DEFINE_SERVICE1(ConOpenMail, HNsmConnection);

//	DEFINE_SERVICE2(ConAddMember, HNsmConnection, PAddMemberInfo);
	DEFINE_SERVICE2(ConRemoveMember, HNsmConnection, PRemoveMemberInfo);
//	DEFINE_SERVICE2(ConChangeMemberGroup, HNsmConnection, PMemberGroupInfo);

	DEFINE_SERVICE2(ConAddGroup, HNsmConnection, LPCWSTR);
	DEFINE_SERVICE2(ConRemoveGroup, HNsmConnection, int);
//	DEFINE_SERVICE2(ConChangeGroupName, HNsmConnection, PGroupNameInfo);

	DEFINE_SERVICE2(SesOpen, HNsmConnection, POpenSessionInfo);
	DEFINE_SERVICE1(SesClose, HNsmSession);
	DEFINE_SERVICE2(SesInviteMember, HNsmSession, LPCSTR);
	DEFINE_SERVICE2(SesSendMessage, HNsmSession, PMessageInfo);
//	DEFINE_SERVICE1(SesBeginTyping, HNsmSession);
//	DEFINE_SERVICE1(SesEndTyping, HNsmSession);

//	DEFINE_SERVICE2(FSOpen, HNsmSession, POpenFileSessionInfo);
//	DEFINE_SERVICE1(FSClose, HNsmFileSession);
//	DEFINE_SERVICE1(FSAccept, HNsmFileSession);
//	DEFINE_SERVICE1(FSCancel, HNsmFileSession);

	DEFINE_SERVICE1(ShowOptionDialog, HWND);
	//DEFINE_SERVICE2(, HNsmConnection, PNsmUISerivceInfo);

private:
	int DoConConnect(PLoginInfo pli);
	int DoConDisconnect(HNsmConnection hConnection);
//	int DoConChangeUserStatus(HNsmConnection hConnection, PUserStatusInfo pusi);
	int DoConChangeUserName(HNsmConnection hConnection, PUserNameInfo puni);
//	int DoConOpenMail(HNsmConnection hConnection);

	int DoConAddMember(HNsmConnection hConnection, PAddMemberInfo pami);
	int DoConRemoveMember(HNsmConnection hConnection, PRemoveMemberInfo prmi);
//	int DoConChangeMemberGroup(HNsmConnection hConnection, PMemberGroupInfo pmgi);

	int DoConAddGroup(HNsmConnection hConnection, LPCWSTR lpwGroupName);
	int DoConRemoveGroup(HNsmConnection hConnection, int nGroupID);
//	int DoConChangeGroupName(HNsmConnection hConnection, PGroupNameInfo pgni);

	int DoSesOpen(HNsmConnection hConnection, POpenSessionInfo posi);
	int DoSesClose(HNsmSession hSession);
	int DoSesInviteMember(HNsmSession hSession, LPCSTR lpAccount);
	int DoSesSendMessage(HNsmSession hSession, PMessageInfo pmi);
//	int DoSesBeginTyping(HNsmSession hSession);
//	int DoSesEndTyping(HNsmSession hSession);

//	int DoFSOpen(HNsmSession hSession, POpenFileSessionInfo pofsi);
//	int DoFSClose(HNsmFileSession hFileSession);
//	int DoFSAccept(HNsmFileSession hFileSession);
//	int DoFSCancel(HNsmFileSession hFileSession);

	int DoShowOptionDialog(HWND hWnd);

// I[o[Ch
public:
	int OnInitialize();
	void OnTerminate();
	int OnSystemModulesLoaded();
};
