#pragma once
#include <map>
#include "IRCSession.h"

class CIRCSesList
{
private:
	typedef std::map<std::string, CIRCSession*> SesMap;

public:
	typedef SesMap::iterator iterator;

private:
	SesMap m_map;

public:
	CIRCSession* find(LPCSTR name)
	{
		iterator i = m_map.find(name);
		return (i == m_map.end()) ? NULL: i->second;
	}
	CIRCSession* find(HNsmSession hSession)
	{
		return NULL;
	}
	iterator begin()
	{ return m_map.begin(); }
	iterator end()
	{ return m_map.end(); }
	void erase(iterator i)
	{
		m_map.erase(i);
	}
	void Create(LPCSTR ch, HNsmSession hSession)
	{
		_ASSERT( m_map.find(ch) == m_map.end() );
		CIRCSession *ses = new CIRCSession(ch, hSession);
		m_map[ch] = ses;
	}
	void Delete(LPCSTR ch)
	{
		iterator i = m_map.find(ch);
		if( i != m_map.end() ){
			delete i->second;
			m_map.erase(i);
		}
	}
};
