#pragma once
#include "setting_struct.h"
#include "../nsmsgs/optionsettings.h"

//******************************************************************

#define IRC_SETTINGS	(CIRCSettings::GetInstance())

//******************************************************************


class CIRCSettings :
	public COptionSettings
{
// singleton -->
private:
	static CIRCSettings m_singleton;

private:
	CIRCSettings(LPCTSTR pluginName);
	~CIRCSettings(void);

public:
	static CIRCSettings& GetInstance()
	{
		return m_singleton;
	}
// <-- singleton

public:
	bool GetAccSetting(AccSetting &set);
	void SetConChList(LPCSTR acc, const ConChList &ccl);
	void ShowOptionDialog(HINSTANCE hInst, HWND hWnd);

private:
	int GetAccountNo(LPCSTR acc);
	void SetAccSetting(int no, AccSetting &set);
	void GetAllAccountInfo(AccountList &list);
	void GetCommonSettings(CommonSettings &cs);
	void SetAllAccountInfo(AccountList &list);
	void SetCommonSettings(CommonSettings &cs);
	void UnloadAllAccountInfo(AccountList &list);
	void DeleteAllAccountSections();
};
