#pragma once
#include <string>

class CIRCUser
{
private:
	const std::string m_acc;
	std::string m_nick;
	u_int m_mode;

public:
	CIRCUser(LPCSTR nick, LPCSTR acc, u_int mode=NULL)
		: m_nick(nick)
		, m_acc(acc)
		, m_mode(mode)
	{
	}
	~CIRCUser(void)
	{
	}
	CIRCUser& operator =(CIRCUser& /*other*/)
	{ _ASSERT(FALSE); return *this; }

public:
	void SetNick(LPCSTR nick)
	{ m_nick = nick; }

	void SetMode(u_int mode)
	{ m_mode = mode; }

	u_int GetMode()
	{ return m_mode; }

	LPCSTR GetMapKey()
	{ return m_nick.c_str(); }

	LPCSTR GetAccount()
	{ return m_acc.c_str(); }

public:
	const static u_int MODE_OPER = (1 << 0);
	const static u_int MODE_CHOP = (1 << 1);
	const static u_int MODE_VOICE = (1 << 2);
};
